=== debian/changelog ===
cpu-x (5.4.0-0.1) unstable; urgency=medium

  * NMU
  * rules-requires-root now defaults to no
  * new upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 28 Aug 2025 10:44:33 +0100
