=== debian/control ===
Source: cpu-x
Section: x11
Priority: optional
Maintainer: Martin Wimpress <code@wimpress.io>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.12),
               gawk,
               gettext,
               libcpuid-dev (>= 0.8.0+repack1-0.3),
               libgtkmm-3.0-dev (>= 3.12),
               libcurl4-gnutls-dev,
               libegl-dev (>= 1.5),
               libjson-c-dev,
               libncurses-dev,
               libpci-dev (>= 3.13),
               libproc2-dev,
               libstatgrab-dev,
               libvulkan-dev,
	       vulkan-validationlayers,
	       glslang-tools,
	       glslc,
               opencl-headers,
	       ocl-icd-opencl-dev,
               nasm,
               pkgconf,
               procps,
Standards-Version: 4.7.2
Homepage: https://github.com/X0rg/CPU-X
Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
Vcs-Browser: https://salsa.debian.org/debian/cpu-x

Package: cpu-x
Architecture: any-linux-amd64 any-linux-i386 any-linux-arm any-linux-armeb any-linux-arm64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         procps,
Description: Tool that gathers information on CPU, motherboard and more
 CPU-X is similar to CPU-Z (for MS Windows). It can be used in graphical
 mode by using GTK or in text-based mode by using NCurses. A dump mode is
 present from the command line.
