=== debian/rules ===
#!/usr/bin/make -f

NULL=

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CMAKE_FLAGS := $(shell dpkg-architecture --equal x32 && echo -DWITH_BANDWIDTH=0)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
