=== debian/watch ===
version=4
https://github.com/X0rg/CPU-X/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
